<?

define("WIZ_UNI_ERROR_LOG_FOLDER", "/bitrix/wizards/grain/prop.join/logs/");

class GUniWizardTools {

	/* 
	
	Recursive folder scan
	
	Usage: $arVars["FILES"] = GUniWizardTools::rscandir($_SERVER["DOCUMENT_ROOT"]."/lib4/");
	
	 */

	function rscandir($base='', &$data=array()) {
	  
		$array = array_diff(scandir($base), array('.', '..')); # remove ' and .. from the array */
		 
		foreach($array as $value) : /* loop through the array at the level of the supplied $base */
		
			if (is_dir($base.$value)) : /* if this is a directory */

				$data[] = $base.$value.'/'; /* add it to the $data array */
				$data = GUniWizardTools::rscandir($base.$value.'/', $data); /* then make a recursive call with the 
				current $value as the $base supplying the $data array to carry into the recursion */
			  
			elseif (is_file($base.$value)) : /* else if the current $value is a file */

				$data[] = $base.$value; /* just add the current $value to the $data array */
			  
			endif;
		  
		endforeach;
		
		return $data; // return the $data array
	  
	}


	function ConvertToLatinica($name) {
	
		$arSymbols = Array(
			" " => "-",
			"а" => "a",
			"б" => "b",
			"в" => "v",
			"г" => "g",
			"д" => "d",
			"е" => "e",
			"ё" => "e",
			"ж" => "j",
			"з" => "z",
			"и" => "i",
			"й" => "y",
			"к" => "k",
			"л" => "l",
			"м" => "m",
			"н" => "n",
			"о" => "o",
			"п" => "p",
			"р" => "r",
			"с" => "s",
			"т" => "t",
			"у" => "u",
			"ф" => "f",
			"х" => "h",
			"ц" => "c",
			"ч" => "ch",
			"ш" => "sh",
			"щ" => "sch",
			"ъ" => "",
			"ы" => "i",
			"ь" => "",
			"э" => "e",
			"ю" => "yu",
			"я" => "ya",
			"А" => "A",
			"Б" => "B",
			"В" => "V",
			"Г" => "G",
			"Д" => "D",
			"Е" => "E",
			"Ё" => "E",
			"Ж" => "J",
			"З" => "Z",
			"И" => "I",
			"Й" => "Y",
			"К" => "K",
			"Л" => "L",
			"М" => "M",
			"Н" => "N",
			"О" => "O",
			"П" => "P",
			"Р" => "R",
			"С" => "S",
			"Т" => "T",
			"У" => "U",
			"Ф" => "F",
			"Х" => "H",
			"Ц" => "C",
			"Ч" => "Ch",
			"Ш" => "Sh",
			"Щ" => "Sch",
			"Ъ" => "",
			"Ы" => "I",
			"Ь" => "",
			"Э" => "E",
			"Ю" => "Yu",
			"Я" => "Ya",

		);
	
		$decoded_name = "";
	
		for($i=0;$i<strlen($name);$i++) {
		
			if(array_key_exists(substr($name,$i,1),$arSymbols)) $decoded_name .= $arSymbols[substr($name,$i,1)];
			else $decoded_name .= substr($name,$i,1);
		
		}
	
		return $decoded_name;

	}

	
	function ucfirst($name) { // make first letter big
	
		$arSymbols = Array(
			"а" => "A",
			"б" => "Б",
			"в" => "В",
			"г" => "Г",
			"д" => "Д",
			"е" => "Е",
			"ё" => "Ё",
			"ж" => "Ж",
			"з" => "З",
			"и" => "И",
			"й" => "Й",
			"к" => "К",
			"л" => "Л",
			"м" => "М",
			"н" => "Н",
			"о" => "О",
			"п" => "П",
			"р" => "Р",
			"с" => "С",
			"т" => "Т",
			"у" => "У",
			"ф" => "Ф",
			"х" => "Х",
			"ц" => "Ц",
			"ч" => "Ч",
			"ш" => "Ш",
			"щ" => "Щ",
			"ъ" => "Ъ",
			"ы" => "Ы",
			"ь" => "Ь",
			"э" => "Э",
			"ю" => "Ю",
			"я" => "Я",
		);
	
		$decoded_name = "";
	
		for($i=0;$i<strlen($name);$i++) {
		
			if($i==0 && array_key_exists(substr($name,$i,1),$arSymbols)) $decoded_name .= $arSymbols[substr($name,$i,1)];
			else $decoded_name .= substr($name,$i,1);
		
		}
	
		return $decoded_name;

	}


	function GetFoldersList($parent_folder) {
	
		$arFilesList = scandir($_SERVER["DOCUMENT_ROOT"].WIZ_UNI_DATA_DIR.$parent_folder);
		$arFolders = Array();
		if(is_array($arFilesList))
			foreach($arFilesList as $file) 
				if(!in_array($file,Array(".","..")) && is_dir($_SERVER["DOCUMENT_ROOT"].WIZ_UNI_DATA_DIR.$parent_folder."/".$file))
					$arFolders[] = $file;
		return $arFolders;
	
	}


	function GetLogList() {
	
		if(!defined("WIZ_UNI_ERROR_LOG_FOLDER") || !file_exists($_SERVER["DOCUMENT_ROOT"].WIZ_UNI_ERROR_LOG_FOLDER))
			return Array();
	
		$arFilesList = scandir($_SERVER["DOCUMENT_ROOT"].WIZ_UNI_ERROR_LOG_FOLDER);
		$arFiles = Array();
		if(is_array($arFilesList))
			foreach($arFilesList as $file) 
				if(!in_array($file,Array(".","..")) && is_file($_SERVER["DOCUMENT_ROOT"].WIZ_UNI_ERROR_LOG_FOLDER.$file))
					$arFiles[] = $file;
		return $arFiles;
	
	}


	function ClearLogs() {
	
		if(!defined("WIZ_UNI_ERROR_LOG_FOLDER") || !file_exists($_SERVER["DOCUMENT_ROOT"].WIZ_UNI_ERROR_LOG_FOLDER))
			return false;
	
		$arFilesList = scandir($_SERVER["DOCUMENT_ROOT"].WIZ_UNI_ERROR_LOG_FOLDER);
		if(is_array($arFilesList))
			foreach($arFilesList as $file) 
				if(!in_array($file,Array(".","..")) && is_file($_SERVER["DOCUMENT_ROOT"].WIZ_UNI_ERROR_LOG_FOLDER.$file))
					unlink($_SERVER["DOCUMENT_ROOT"].WIZ_UNI_ERROR_LOG_FOLDER.$file);
		return true;
	
	}


	function GetRandomFile($type_folder,$arFolders) {

		$arFiles = Array();	
		foreach($arFolders as $folder) {
			$arFilesList = scandir($_SERVER["DOCUMENT_ROOT"].WIZ_UNI_DATA_DIR.$type_folder."/".$folder);
			if(is_array($arFilesList))
				foreach($arFilesList as $file) 
					if(!in_array($file,Array(".","..")) && is_file($_SERVER["DOCUMENT_ROOT"].WIZ_UNI_DATA_DIR.$type_folder."/".$folder."/".$file))
						$arFiles[] = WIZ_UNI_DATA_DIR.$type_folder."/".$folder."/".$file;
		}
					
		if(count($arFiles)>0) return $arFiles[rand(0,(count($arFiles)-1))];
		else return false;
	
	}

	function GetRandomImage($arFolders) {

		$max_iterations = 10;
		
		do {
			$max_iterations--;
			$random_image_file = GFloodWizardTools::GetRandomFile("images",$arFolders);
			if($random_image_file===false) return false;
		} while (!CFile::IsImage($random_image_file) && $max_iterations>=0);
		
		return $random_image_file;
		
	}
	
	function StoreVars($arVars) {
	
		if(!is_array($arVars)) $arVars = Array();
	
		$vars_data = "<?\n\$VARS = ".var_export($arVars,true).";\n?>";		
	
		$handle = fopen($_SERVER["DOCUMENT_ROOT"].WIZ_UNI_VARS_DIR."vars.php", "w");
		fwrite($handle, $vars_data);
		fclose($handle);
	
	}
	
	function GetVars() {
	
		$VARS = Array();
	
		$handle = fopen($_SERVER["DOCUMENT_ROOT"].WIZ_UNI_VARS_DIR."vars.php", "r");
		$vars_data=fread($handle, filesize($_SERVER["DOCUMENT_ROOT"].WIZ_UNI_VARS_DIR."vars.php"));
		fclose($handle);
		
		ob_start();
		eval("?>".$vars_data."<?");
		$err = ob_get_contents();
		ob_end_clean();

		return $VARS;
	
	}
	
	function AddErrorToLog($str_error,$str_personal_info="",$error_type="error") {
	
		if(strlen($str_error)<=0) return;
	
		if(!is_array($_SESSION["WIZ_UNI_ERROR_LOG"])) $_SESSION["WIZ_UNI_ERROR_LOG"] = Array();
		
		$found_key = false;
		foreach($_SESSION["WIZ_UNI_ERROR_LOG"] as $k=>$arError) 
			if($arError["ERROR"]==$str_error)
				$found_key = $k;

		if($found_key===false) {
			$_SESSION["WIZ_UNI_ERROR_LOG"][] = Array(
				"ERROR"=>$str_error,
				"COUNT"=>1,
				"TYPE"=>$error_type,
			);
			$found_key=count($_SESSION["WIZ_UNI_ERROR_LOG"])-1;
		} else {
			$_SESSION["WIZ_UNI_ERROR_LOG"][$found_key]["COUNT"]++;
			$_SESSION["WIZ_UNI_ERROR_LOG"][$found_key]["TYPE"]=$error_type;
		}
		
		if(defined("WIZ_UNI_ERROR_LOG_FOLDER") && strlen($str_personal_info)>0) {
		
			global $temporary_error_personal;
			if(!is_array($temporary_error_personal)) $temporary_error_personal = Array();
			if(!is_array($temporary_error_personal[$found_key])) $temporary_error_personal[$found_key] = Array();
			$temporary_error_personal[$found_key][] = $str_personal_info;
		
		}
	
	}

	function GetErrorLog() {

		if(is_array($_SESSION["WIZ_UNI_ERROR_LOG"])) return $_SESSION["WIZ_UNI_ERROR_LOG"];
		else return Array();
	
	}

	function GetErrorCount() {

		$arErrCount = Array("ERRORS"=>0,"WARNINGS"=>0,"MESSAGES"=>0);

		if(is_array($_SESSION["WIZ_UNI_ERROR_LOG"])) {
		
			foreach($_SESSION["WIZ_UNI_ERROR_LOG"] as $k=>$arError) {
			
				if($arError["TYPE"]=="error" || !$arError["TYPE"]) {
				
					$arErrCount["ERRORS"] += $arError["COUNT"];
				
				} elseif($arError["TYPE"]=="warning") {
				
					$arErrCount["WARNINGS"] += $arError["COUNT"];

				} elseif($arError["TYPE"]=="message") {
				
					$arErrCount["MESSAGES"] += $arError["COUNT"];

				}
			
			}
			
		}
	
		return $arErrCount;
	
	}

	function StorePersonalErrorLog() {

		global $temporary_error_personal;
	
		if(defined("WIZ_UNI_ERROR_LOG_FOLDER") && is_array($temporary_error_personal)) {
		
			foreach($temporary_error_personal as $error_key=>$arPersonalInfo) {
			
				$filename = $_SERVER["DOCUMENT_ROOT"].WIZ_UNI_ERROR_LOG_FOLDER.$error_key.".txt";
				
				if(file_exists($filename)) {
				
					$handle = fopen($filename, "a");
				
				} else {
				
					$handle = fopen($filename, "w");
					fwrite($handle, $_SESSION["WIZ_UNI_ERROR_LOG"][$error_key]["ERROR"]."\nCreated: ".date("r")."\n===================================\n");
				
				}

				fwrite($handle, implode("\n",$arPersonalInfo)."\n");
				fclose($handle);
			
			}
		
		}
	
	}

	

	function StoreParentSections($arCurParentSections) {
	
		if($arCurParentSections===false) {
			$arCurParentSections = Array();
			for($i=1;$i<=4;$i++) $arCurParentSections[$i] = Array();
		}
	
		$vars_data = "<?\n\$arCurParentSections = ".var_export($arCurParentSections,true).";\n?>";		

		$handle = fopen($_SERVER["DOCUMENT_ROOT"].WIZ_UNI_VARS_DIR."sections.php", "w");
		fwrite($handle,$vars_data);
		fclose($handle);
	
	}

	function GetParentSections(&$arCurParentSections) {
	
		$arCurParentSections = Array();
	
		$handle = fopen($_SERVER["DOCUMENT_ROOT"].WIZ_UNI_VARS_DIR."sections.php", "r");
		$vars_data=fread($handle, filesize($_SERVER["DOCUMENT_ROOT"].WIZ_UNI_VARS_DIR."sections.php"));
		fclose($handle);
		
		ob_start();
		eval("?>".$vars_data."<?");
		$err = ob_get_contents();
		ob_end_clean();

		if(!is_array($arCurParentSections) || count($arCurParentSections)!=4) {
		
			$arCurParentSections = Array();
			for($i=1;$i<=4;$i++) $arCurParentSections[$i] = Array();
			
		}
	
	}


	function ShowAdv($obWizard) {

		$wizard = &$obWizard->GetWizard();
		$wizard_path = $wizard->GetPath();

		ob_start();

		?>
		<style>
		table.grain-wizard-adv { width: 100%; border: 1px solid #DDDDDD }
		table.grain-wizard-adv td { padding: 10px; vertical-align: top; color: #555555 }
		table.grain-wizard-adv td.grain-wizard-adv-col-logo { width: 90px; padding-top: 12px; padding-right: 0 }
		table.grain-wizard-adv td.grain-wizard-adv-col-info { padding-left: 0 }
		</style>
		<br /><br /><br /><br />
		<table class="grain-wizard-adv" cellpadding="0" cellspacing="0">
			<tr>
				<td class="grain-wizard-adv-col-logo">
					<a href="http://g-rain-design.ru/"><img src="<?=$wizard_path?>/images/logo.png" width="72" height="68" border="0" /></a>
				</td>
				<td class="grain-wizard-adv-col-info">
					<?=GetMessage("GRADV_THIS_IS_A_FREE_WIZARD")?><br /><br />
					<?=GetMessage("GRADV_OTHER_MODULES")?>: <a href="http://g-rain-design.ru/components/">http://g-rain-design.ru/components/</a>
				</td>
			</tr>
		</table>
		<?		
		
		$html = ob_get_contents();
		ob_end_clean();

		return $html;

	}


}

?>